+++
title = "Converting Imaginary Integrals to real ones"
template = "page.html"
date = 2020-05-15
+++

Okay it's 6 steps and if you do it enough times it will be down to only 5 steps.

Just so all of this actually makes sense, we will be using the following example:

$$
f(z) = \frac{1}{z}
$$

Above equation is to be integrated along the circle|z|=R, starting and finishing on the route.

Before getting into the sateps lets make use we know the basics

## Basic Definition

An imaginary number is conventionally denoted as

$$
z = x + \iota y
$$

and a function is denoted as
$$
f(z) = u(x, y) + \iota v(x, y)
$$

here \`u\` and \`v\` are functions of \`x\` and \`y\`, and that \`i\` thing is iota also known as root of -1.

## 1) Path

Write the path in terms of only one variable, conventionally \`t\`. So, here we can write 'z' as:

$$
z = R \cos t + \iota R \sin t
$$

from this we can directly compare and get \`x\` and \`y\`

$$
x = R \cos t
$$

$$
y = R \sin t
$$

That was all step 1 was.

## 2) Function to x y

Now we will get function which is in terms of 'u' and 'v' into terms of 'x' and 'y'.

$$
f(z) = \frac{1}{z}
$$

$$
f(z) = \frac{1}{x + \iota y}
$$

$$
f(z) = \frac{x-\iota y}{x^2 + y^2}
$$

From this we can take out values of 'u' and 'v' as

$$
u = \frac{x}{x^2+y^2};v = -\frac{y}{x^2+y^2}
$$

## 3) uv to t

At this step substitute the earlier values of 'u' and 'v' we have in terms of 'x' and 'y', to have it in terms to 't'.

$$
u = \frac{\cos t} {R}
$$

$$
v = -\frac{\sin t} {R}
$$

We are almost done now.

## 4) Piecing it all together

Now plug them into this equation you can do the following.

$$
\int{f(z)} = \int{u\frac{dx}{dt}dt} - \int{v\frac{dy}{dt}dt} + \iota\int{u\frac{dy}{dt}dt} +\iota\int{u\frac{dx}{dt}dt}
$$
## 5) Precaution

In the very likely case you forget the equation:

You can get it directly from this:

$$
\int{f(z)dz} = \int{(u+\iota v)(dx + \iota dy)}
$$

Just multiply those two brackets in the L.H.S and you'll be at the equation above it in 2 lines.
